Bug 498719 - [patch] mac80211: nullfunc and hidden SSID fixes
[patch] mac80211: nullfunc and hidden SSID fixes
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.4
All Linux
low Severity medium
: rc
: ---
Assigned To: John W. Linville
Red Hat Kernel QE team
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-05-02 10:13 EDT by Dan Williams
Modified: 2009-09-02 04:59 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 04:59:37 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
scanning fixes for mac80211 (3.09 KB, patch)
2009-05-02 10:13 EDT, Dan Williams
no flags Details | Diff

  None (edit)
Description Dan Williams 2009-05-02 10:13:37 EDT
Created attachment 342178 [details]
scanning fixes for mac80211

Fix #1:

When returning from a scan, the stack tried to probe the last-scanned SSID, which is completely wrong, and may not even have existed.  It's supposed to be probing the previously associated SSID instead.  This caused the stack to periodically disconnect from hidden-SSID access points becuase the hidden SSID doesn't show up in the scan list, and the probe-request to that SSID is required to determine if its still present.

Fix #2:

The mac80211 stack sends null packets when beginning a scan to alert the AP that it should buffer frames for the STA while the STA is scanning.  However, the TX path of mac80211 would simply drop these frames on the floor, causing the AP not to buffer frames, and leading to deauthentications due to excessive retries on the AP.

This leads to choppy or broken streaming video, intermittent connection failures when using NetworkManager due to the extra steps required to reauthenticate to the AP when it has dropped you due to excessive retries, etc.

This patch came out of the debugging sessions I've been having with a large customer of the past 3 weeks.  See bug #493745 & IT #283289 for the details.
Comment 1 John W. Linville 2009-05-05 10:34:28 EDT
Test kernels w/ the attached patch are available here:

   http://people.redhat.com/linville/kernels/rhel5/

Please give them a try and post the results...thanks!
Comment 2 RHEL Product and Program Management 2009-05-05 10:48:55 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 4 John Walicki 2009-05-05 21:25:13 EDT
Dan - Thanks for your support on these patches.  Huge improvement in wireless stability. 

I'll post in the IssueTracker ticket to advocate for inclusion in RHEL 5.4
Comment 5 Don Zickus 2009-05-12 13:41:37 EDT
in kernel-2.6.18-146.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.
Comment 8 errata-xmlrpc 2009-09-02 04:59:37 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1243.html

Note You need to log in before you can comment on or make changes to this bug.